#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class SidfmdProduct < ActiveRecord::Base
  has_many :sidfmd_versions
  has_many :sidfmd_rule_cm_lapp_subs, dependent: :delete_all

  UNREGISTRABLE_PRODUCTS = [ 'Red Hat Linux', 'CentOS', 'Amazon Linux AMI', 'Debian GNU/Linux', 'Ubuntu' ]

  def os?
    category ? category == 'OS' : false
  end

  def self.unregistrable_product_ids
    pids = SidfmdProduct.where(:name => UNREGISTRABLE_PRODUCTS).pluck(:pid)
  end
end
