/* coding: utf-8 */
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){

    function execute_filter(filters){
        reset_pages_checked_values();
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    };

    //prevent dropdown-menu from closing by click
    $('.filter-dropdown-menu *').on('click', function(e){
        e.stopPropagation();
    });

    //期間指定検索
    $('.filter-date-preset').on('click', function() {
        $('#filters_search_date_begin').val($(this).data('begindate'));
        $('#filters_search_date_end').val($(this).data('enddate'));
        $('#filters_search_date_in_rev').prop('checked', $(this).data('inrev') ? true : false);
        return false;
    });


    $('#filter-date-form').on('submit', function() {
        var pages_filters = $('#pages_filters');
        var filters = JSON.parse(pages_filters.val());
        var begindate = $('#filters_search_date_begin').val();
        var enddate = $('#filters_search_date_end').val();
        var inrev = $('#filters_search_date_in_rev').prop('checked');
        var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
        filters['date'] = String(v);
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-date').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['date'] = '::';
        execute_filter(filters);
        return false;
    }); 

    //SRI検索
    $('#exec-filter-statuses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var sris = [];
        $('#filter-statuses-menu [data-sri]:checked').each(function(){
            sris.push($(this).val());
        });
        filters['sris'] = sris;
        filters['warning'] = 'all';
        execute_filter(filters);
        return false;
    }); 

    $('#reset-filter-statuses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['sris'] = [];
        execute_filter(filters);
        return false;
    });

    //CVSS検索
    $('#exec-filter-cvsses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var cvsses = [];
        $('#filter-cvsses-menu [data-cvss]:checked').each(function(){
            cvsses.push($(this).val());
        });
        filters['cvsses'] = cvsses;
        filters['warning'] = 'all';
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-cvsses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['cvsses'] = [];
        execute_filter(filters);
        return false;
    });

    //履歴検索
    $('.filter-journal-preset').on('click', function(){
       $('#filters_search_journal_begin').val($(this).attr('data-begindate'));
       $('#filters_search_journal_end').val($(this).attr('data-enddate'));
       $('#filters_search_journal_in_rev').prop('checked', $(this).data('inrev') ? true : false);
       return false;
   });

   $('#filter-journal-form').on('submit', function(){
       var begindate = $('#filters_search_journal_begin').val();
       var enddate = $('#filters_search_journal_end').val();
       if( begindate == '' && enddate == '' ){
           alert('期間を指定して下さい');
           return false;
       }
       var filters = JSON.parse($('#pages_filters').val());
       var inrev = $('#filters_search_journal_in_rev').prop('checked');
       var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
       filters['journal']['period'] = String(v);
       filters['journal']['filter_status_change'] = $('#filter-journal-filter-status-change').prop('checked');
       filters['journal']['filter_duedate_change'] = $('#filter-journal-filter-duedate-change').prop('checked');
       execute_filter(filters);
       return false;
   });

   $('#reset-filter-journal').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       filters['journal']['period'] = '::';
       filters['journal']['filter_status_change'] = false;
       filters['journal']['filter_duedate_change'] = false;
       execute_filter(filters);
       return false;
   });

   //カテゴリ検索(複数)
   $('#filter-categories-is-and-check-box').on('change', function(){
        if( $(this).prop('checked') ){
            $('#filter-categories-is-except-check-box').prop('checked', false);
        }
    });

    $('#filter-categories-is-except-check-box').on('change', function(){
        if( $(this).prop('checked') ){
            $('#filter-categories-is-and-check-box').prop('checked', false);
        }
    });

    if( $('#filter-categories-menu #filter-categories-is-notreg-check-box').length === 1 ){
        $('#filter-categories-is-notreg-check-box').on('change', function(){
            if( $(this).prop('checked') ){
                $('#filter-categories-is-and-check-box, #filter-categories-is-except-check-box').prop('checked', false);
                $('#filter-summary-category-tab-content input[type="checkbox"]').prop('disabled', true);
            }else{
                $('#filter-summary-category-tab-content input[type="checkbox"]').prop('disabled', false);
            }
        });

        $('#filter-categories-is-and-check-box, #filter-categories-is-except-check-box').on('change', function(){
           if( $(this).prop('checked') ){
                $('#filter-categories-is-notreg-check-box').prop('checked', false);
                $('#filter-summary-category-tab-content input[type="checkbox"]').prop('disabled', false);
            }
        });
    }

    $('#exec-filter-categories').on('click', function(){
        var cat_ids = [];
        $('#filter-categories-menu .category-select:checked').each(function(){
            cat_ids.push($(this).val());
        });
        if( cat_ids.length === 0){
            if( $('#filter-categories-menu #filter-categories-is-notreg-check-box:checked').length === 0 ){
                alert('カテゴリを1つ以上選択して下さい');
                return false;
            }
        }
        var filters = JSON.parse($('#pages_filters').val());
        const is_notreg_check_box = $('#filter-categories-menu #filter-categories-is-notreg-check-box');
        if( is_notreg_check_box.length === 1 ){
            filters['categories']['is_notreg'] = is_notreg_check_box.prop('checked');
        }
        if( filters['categories']['is_notreg'] === true ){
            filters['categories']['ids'] = [];
            filters['categories']['is_and'] = false;
            filters['categories']['is_except'] = false;
        }else{
            filters['categories']['ids'] = cat_ids;
            filters['categories']['is_and'] = $('#filter-categories-is-and-check-box').prop('checked');
            filters['categories']['is_except'] = $('#filter-categories-is-except-check-box').prop('checked');
        }
        execute_filter(filters);
    });

    (function(){
        var target_tab_content = ($.cookie('summary_category_tag') === 'custom_category' ? '#filter-summary-category-select-custom-category-tab-content' : '#filter-summary-category-select-system-category-tab-content');
        $('#filter-categories-menu li [data-target="' + target_tab_content + '"]').addClass('active');
        $(target_tab_content).show();

        $('#filter-categories-menu .nav-link').on('click', function(e){
            var tab_item = $(this);
            if( !tab_item.hasClass('active') ){
                var target_content_id = tab_item.data('target');
                $('#filter-categories-menu .nav-link, #filter-categories-menu .nav-item').removeClass('active');
                tab_item.addClass('active');
                tab_item.closest('.nav-item').addClass('active');
                $('#filter-summary-category-tab-content [data-tabcontent="true"]').hide();
                $(target_content_id).show();
                $.cookie('summary_category_tag', (target_content_id.indexOf('system-category') === -1 ? 'custom_category' : 'system_category'), { path:'/' });
            }
            e.stopPropagation();
        });
    })();

    //カテゴリ検索リセット
    $('#reset-filter-categories').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['categories']['ids'] = [];
        filters['categories']['is_and'] = false;
        filters['categories']['is_except'] = false;
        if( $('#filter-categories-menu #filter-categories-is-notreg-check-box:checked').length === 1 ){
            filters['categories']['is_notreg'] = false;
        }
        execute_filter(filters);
    });

});


//上記の検索を関数に移行予定。管理しやすく(使いやすく)バグが発生しにくくするため。

function execute_filter(filters){
    reset_pages_checked_values();
    $('#pages_filters').val(JSON.stringify(filters));
    $('#pages_offset').val('0');
    $('#pages_form').submit();
    return false;
};

//有効期間/対策予定日検索
function enable_filter_date2(item){
    $('#exec-filter-date2').on('click', function(){
        let filters = JSON.parse($('#pages_filters').val());
        let begin_date = $('#filter-date2-begin-date-field').val();
        let end_date = $('#filter-date2-end-date-field').val();
        const notset = $('#filter-date2-notset').prop('checked');
        if( notset ){
            begin_date = '';
            end_date = ''; 
        }
        filters[item] = String((notset ? 'notset' : '') + ':' + begin_date + ':' + end_date);
        execute_filter(filters);
        return false;
    });

    $('#filter-date2-preset [data-preset="true"]').on('click', function(){
        $('#filter-date2-begin-date-field').val($(this).attr('data-begindate'));
        $('#filter-date2-end-date-field').val($(this).attr('data-enddate'));
        $('#filter-date2-notset').prop('checked', ('notset' === $(this).attr('data-notset')));
    });

    $('#filter-date2-notset').on('change', function(){
        if( $(this).prop('checked') ) {
            $('#filter-date2-begin-date-field, #filter-date2-end-date-field').val('');
        }
    });

    $('#reset-filter-date2').on('click', function(){
        let filters = JSON.parse($('#pages_filters').val());
        filters[item] = '::';
        execute_filter(filters);
        return false;
    });
}

//テキスト検索
function enable_filter_text(item_name, input_id, filter_button_id, reset_button_id, notreg_checkbox_elm_id = ''){
    $('#' + filter_button_id).on('click', function(){
       let filter = JSON.parse($('#pages_filters').val());
       let text = $('#' + input_id).val();
       if( notreg_checkbox_elm_id.length > 0 ){
           filter[item_name]['is_target_notreg'] = $('#' + notreg_checkbox_elm_id).prop('checked');
           if( filter[item_name]['is_target_notreg'] ){
               filter[item_name]['text'] = '';
           }else{
               filter[item_name]['text'] = text;
           }
       }else{
           filter[item_name] = text
       }
       execute_filter(filter);
       return false;
   });

   $('#' + reset_button_id).on('click', function(){
       let filter = JSON.parse($('#pages_filters').val());
       if( notreg_checkbox_elm_id.length > 0 ){
           filter[item_name]['text'] = '';
           filter[item_name]['is_target_notreg'] = false;
       }else{
           filter[item_name] = ''
       }
       execute_filter(filter);
       return false;
   });
}

//「SRI重大度/CVSSスコア 別ホスト数分布」「対応の状況別ホスト数分布」のフィルタ
function enable_filter_by_score_status(){
    $('.filter-change-exclusion').on('click', function() {
        const link = $(this);
        const name = link.attr('data-name');
        let value = link.data('value');
        if( typeof( value ) === 'number' ){
            value = String(value);
        }
        let filters = JSON.parse($('#pages_filters').val());
        const keys = Object.keys(filters);
        keys.forEach( key => {
            let val = null;
            if( key === name ){
                val = value; 
            }else if( key === 'warning' ){
                val = 'all';
            }else if( key === 'status' ){
                val = '0';
            }else if( key === 'sris' || key === 'cvsses' ){
                val = [];
            }else if( key === 'due_date' || key === 'date' ){
                val = '::';
            }else if( key === 'cvss_vector' || key === 'product' ){
                val = {};
            }else if( key === 'journal' ){
                val = { 
                    'period': '::',
                    'filter_status_change': false,
                    'filter_duedate_change': false
                };
            }else if( key === 'categories' ){
                val = {
                    'ids': [],
                    'is_and': false,
                    'is_except': false
                };
            }else{
                val = '';
            }
            filters[[key]] = val;
        });
        if( name === 'sris' || name == 'cvsses' ){
            filters['status'] = '1:2';
        }
        execute_filter(filters);
        return false;
    });
}

//プロダクト検索
function enable_filter_products(pageName){
    const TYPE_PRODUCT = 'product';
    const TYPE_VERSION = 'version';
    const TYPE_LPRODUCT = 'lproduct';
    const TYPE_LVERSION = 'lversion';
    const prodAllVersion = '全て';
    const prodVersionAll = '全バージョン';
    const versionAllNecessary = (pageName === 'hosts' || pageName === 'vulnerability');

    const getResetedFilterProductsParams = () => {
        const filters = JSON.parse($('#pages_filters').val());
        const params = {};
        for( key in filters.products){
            params[key] = [];
        }
        return params;
    };

    const resetFilterProducts = () => {
        var filters = JSON.parse($('#pages_filters').val());
        filters.products = getResetedFilterProductsParams();
        execute_filter(filters);
    };

    const createSelectedProdElm = (prodName, prodId, prodType, isAllVersion = false) => {
        const item = $('<div>').attr({
            'class': 'mr-1',
            'data-prodelm': 'true'
        });
        const unselectIcon = $('<i>').attr({
            'class': 'fas fa-minus-circle ml-1 toggle-minus-circle cursor-pointer',
            'data-id': prodId,
            'data-prodtype': prodType,
            'data-allversion': isAllVersion
        });
        item.append(
            $('<div>').attr('class', 'btn-selected-product').append(
                $('<div>').attr('class', 'd-flex').append(
                    $('<span>').attr('class', 'mr-auto').text(prodName),
                    $('<span>').attr('class', 'ml-auto').append(unselectIcon)
                )
            )
        );

        //プロダクトを除外する処理
        unselectIcon.on('click', function(){
            const searchData = JSON.parse($('#filter-products-selected-data').val());
            const deleteId = $(this).data('id');
            const type = $(this).attr('data-prodtype');
            const isAllVersion = $(this).data('allversion');
            if( type === 'product' ){
                if( isAllVersion ){
                    searchData.product_all_version_ids = searchData.product_all_version_ids.filter( pid => pid != deleteId );
                }else{
                    searchData.product_ids = searchData.product_ids.filter( pid => pid != deleteId );
                }
            }else if( type === 'version' ){
                searchData.version_ids = searchData.version_ids.filter( vid => vid != deleteId );
            }else if( type === 'lproduct' ){
                if( isAllVersion ){
                    searchData.lproduct_all_version_ids = searchData.lproduct_all_version_ids.filter( lpid => lpid != deleteId );
                }else{
                    searchData.lproduct_ids = searchData.lproduct_ids.filter( lpid => lpid != deleteId );
                }
            }else if( type === 'lversion' ){
                searchData.lversion_ids = searchData.lversion_ids.filter( lvid => lvid != deleteId );
            }else{
                return false;
            }
            $(this).closest('[data-prodelm]').remove();
            $('#filter-products-selected-data').val(JSON.stringify(searchData));
        });
        return item;
    };

    $('#filters-search-product-btn').on('click', function(){
       const targetElm = $('#filter-products-selected-list');
       targetElm.html('');
       var button = $(this);
       var prod_name = button.attr('data-productname');
       const searchData = JSON.parse($('#filter-products-selected-data').val());
       $('#filter-products-selected-data').val(JSON.stringify(searchData));
       let { product_ids, version_ids, lproduct_ids, lversion_ids } = searchData;
       const params = {
           product_ids,
           version_ids,
           lproduct_ids,
           lversion_ids,
       };
       if( searchData.product_all_version_ids ){
           params.product_ids = params.product_ids.concat(searchData.product_all_version_ids);
       }
       if( searchData.lproduct_all_version_ids ){
           params.lproduct_ids = params.lproduct_ids.concat(searchData.lproduct_all_version_ids);
       }
       for( key in params ){
           params[key] = JSON.stringify(params[key])
       }
       const appendProdElm = (prodName, prodId, prodType, isAllVersion = false) => {
           setTimeout( () => {
               targetElm.append( createSelectedProdElm(prodName, prodId, prodType, isAllVersion) );
           });
       };
       $.post( $('#get-products-by-ids-path').val(), params, function(data){
           data.products.forEach( prod => {
               const pid = prod.pid;
               if( searchData.product_all_version_ids && searchData.product_all_version_ids.includes(pid) ){
                   appendProdElm(prod.name + '(' + prodVersionAll + ')', pid, TYPE_PRODUCT, true);
               }
               if( searchData.product_ids.includes(pid) ){
                   appendProdElm(prod.name + (versionAllNecessary ? '(' + prodAllVersion + ')' : ''), pid, TYPE_PRODUCT);
               }
           });
           data.versions.forEach( version => {
               const vid = version.vid;
               appendProdElm(version.fullname, vid, TYPE_VERSION);
           });
           data.lproducts.forEach( lprod => {
               const lpid = lprod.id;
               if( searchData.lproduct_all_version_ids && searchData.lproduct_all_version_ids.includes(lpid) ){
                   appendProdElm(lprod.name + '(' + prodVersionAll + ')', lpid, TYPE_LPRODUCT, true);
               }
               if( searchData.lproduct_ids.includes(lpid) ){
                   appendProdElm(lprod.name + (versionAllNecessary ?  '(' + prodAllVersion + ')' : ''), lpid, TYPE_LPRODUCT);
               }
           });
           data.lversions.forEach( lversion => {
               const lvid = lversion.id;
               appendProdElm(lversion.fullname, lvid, TYPE_LVERSION);
           });
           $('#FilterProductModal').modal('show');
           if( Object.values(searchData).filter( ids => ids.length > 0).length > 0 &&
               Object.values(data).filter( ids => ids.length > 0 ).length === 0 
           ){
               alert('検索中のプロダクトが全て削除されています。');
               resetFilterProducts();
           }
       });
   });

   var jqxhr = null;
   $('#filter-product-input').on('input', function(){
       $('[data-toggle="tooltip"]').tooltip('hide');
       if(jqxhr){
           jqxhr.abort();
       }
       var keyword = $(this).val();
       var path = $('#sidfm_licenses_api_substr_search_path').val();
       $('#filter-product-list > *').remove();
       jqxhr = $.get(path, { 'params[keyword]': keyword }, function(data) {
           if(keyword.length < 2){
               if(keyword.length != 0){
                   $('#filter-product-input-tooltip').attr('data-original-title', '2文字以上入力して下さい').tooltip('show');
               }else{
                   $('#filter-product-input-tooltip').tooltip('hide');
               }
           }else{
               $('#filter-product-input-tooltip').tooltip('hide');
               var lproducts = data['lproducts'];
               delete data['lproducts'];
               var pids = Object.keys(data);
               if(pids.length === 0 && lproducts.length === 0){
                   $('#filter-product-input-tooltip').attr('data-original-title', '該当するプロダクトはありません').tooltip('show');
               }else{
                   for (var i = 0; i < pids.length; i++) {
                       var product = data[pids[i]]['product'];
                       var versions = data[pids[i]]['versions'];
                       var p_item = $('<span></span>', {
                           class: 'dropdown'
                       });
                       p_item.append($('<button></button>', {
                           class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                           type: 'button',
                           'data-toggle': 'dropdown',
                           'aria-haspopup': 'true',
                           'aria-expanded': 'false',
                           text: product['name']
                        }));
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                        });

                        if (versions) {
                            if( versionAllNecessary ){
                                p_menu.append(
                                    $('<a>').attr({
                                        class: 'dropdown-item select-search-product',
                                        href: '#',
                                        'data-pid': pids[i],
                                        'data-allversion': 'true',
                                        'data-prodname': product['name'] + '( ' + prodVersionAll + ')'
                                    }).append(
                                        $('<span>').text(prodVersionAll),
                                        $('<i>').attr({
                                            'class': 'fas fa-question-circle c_gray_70',
                                            'data-toggle': 'tooltip',
                                            'data-title': '関連する全てのバージョン',
                                            'data-boundary': 'window'
                                        })
                                    )
                                 );
                             }

                             const productBtn = $('<a>').attr({
                                 class: 'dropdown-item select-search-product',
                                 href: '#',
                                 'data-pid': pids[i],
                                 'data-prodname': product['name'] + (versionAllNecessary ? '( ' + prodAllVersion + ')' : ''),
                             });
                             productBtn.append($('<span>').text(prodAllVersion));

                             if( versionAllNecessary ){
                                 productBtn.append(
                                     $('<i>').attr({
                                         'class': 'fas fa-question-circle c_gray_70',
                                         'data-toggle': 'tooltip',
                                         'data-title': 'ホストとの関連付けで「全て」を指定したもの',
                                         'data-boundary': 'window'
                                     })
                                 );
                             } 
                             p_menu.append(productBtn);
                        }else{
                            p_menu.append(
                                $('<a>').attr({
                                    class: 'dropdown-item select-search-product',
                                    href: '#',
                                    'data-pid': pids[i],
                                    'data-prodname': product['name'] + (versionAllNecessary ? '( ' + prodAllVersion + ')' : ''),
                                }).text(prodAllVersion)
                            );
                        }
                        if (versions) {
                            for (var j = 0; j < versions.length; j++) {
                                var version = versions[j];
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item select-search-product',
                                    href: '#',
                                    text: version['fullname'],
                                    'data-vid': version['vid'],
                                    'data-prodname': version['fullname']
                                });
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#filter-product-list').append(p_item);

                   }
                   for (var i = 0; i < lproducts.length; i++) {
                        var lproduct_data = lproducts[i];
                        var lproduct = lproduct_data['product'];
                        var lversions = lproduct_data['versions'];
                        var p_item = $('<span></span>', {
                            class: 'dropdown lproduct-dropdown'
                        });
                        p_item.append($('<button></button>', {
                            class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                            type: 'button',
                            'data-toggle': 'dropdown',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                            text: lproduct['name']
                        }));
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                                   'aria-labelledby': 'm_searched_item_' + lproduct['id']
                        });
                        if(lversions.length > 0){
                            if( versionAllNecessary ){
                                p_menu.append(
                                    $('<a>').attr({
                                        class: 'dropdown-item select-search-product',
                                        href: '#',
                                        'data-lpid': lproduct['id'],
                                        'data-allversion': 'true',
                                        'data-prodname': lproduct['name'] + '( ' + prodVersionAll + ')'
                                    }).append(
                                        $('<span>').text(prodVersionAll),
                                        $('<i>').attr({
                                            'class': 'fas fa-question-circle c_gray_70',
                                            'data-toggle': 'tooltip',
                                            'data-title': '関連する全てのバージョン',
                                            'data-boundary': 'window'
                                        })
                                    )
                                );
                            }

                            const lproductBtn = $('<a>').attr({
                                class: 'dropdown-item select-search-product',
                                href: '#',
                                'data-lpid': lproduct['id'],
                                'data-prodname': lproduct['name'] + (versionAllNecessary ? '( ' + prodAllVersion + ')' : ''),
                            });
                            lproductBtn.append($('<span>').text(prodAllVersion));

                            if( versionAllNecessary ){
                                lproductBtn.append(
                                    $('<i>').attr({
                                        'class': 'fas fa-question-circle c_gray_70',
                                        'data-toggle': 'tooltip',
                                        'data-title': 'ホストとの関連付けで「全て」を指定したもの',
                                        'data-boundary': 'window'
                                    })
                                );
                            }
                            p_menu.append(lproductBtn);
                        }else{
                            p_menu.append(
                                $('<a>').attr({
                                    class: 'dropdown-item select-search-product',
                                    href: '#',
                                    'data-lpid': lproduct['id'],
                                    'data-prodname': lproduct['name'] + (versionAllNecessary ? '( ' + prodAllVersion + ')' : ''),
                                }).text(prodAllVersion)
                            );
                        }
                        if (lversions.length > 0) {
                            for (var j = 0; j < lversions.length; j++) {
                                var lversion = lversions[j];
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item select-search-product',
                                    href: '#',
                                    text: lversion['fullname'],
                                    'data-lvid': lversion['id'],
                                    'data-prodname': lversion['fullname']
                                });
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#filter-product-list').append(p_item);
                    }
                    $('#filter-product-list').find('[data-toggle="tooltip"]').tooltip();
               }
           }
       });
   });

   //バージョンの選択
   $(document).on('click', '#FilterProductModal .select-search-product', function(e){
       e.stopPropagation();
       const searchData = JSON.parse($('#filter-products-selected-data').val());
       const button = $(this);
       const prodName = button.attr('data-prodname');
       const pid = button.data('pid');
       const vid = button.data('vid');
       const lpid = button.data('lpid');
       const lvid = button.data('lvid');
       const isAllVersion = button.data('allversion');

       let item = null;
       if( pid ){
           if( isAllVersion ){
               if( searchData.product_all_version_ids.includes(pid) ) return;
               searchData.product_all_version_ids.push(pid);
           }else{
               if( searchData.product_ids.includes(pid) ) return;
               searchData.product_ids.push(pid);
           }
           item = createSelectedProdElm(prodName, pid, TYPE_PRODUCT, !!isAllVersion);
       }else if( vid ){
           if( searchData.version_ids.includes(vid) ) return;
           searchData.version_ids.push(vid);
           item = createSelectedProdElm(prodName, vid, TYPE_VERSION);
       }else if( lpid ){
           if( isAllVersion ){
               if( searchData.lproduct_all_version_ids.includes(lpid) ) return;
               searchData.lproduct_all_version_ids.push(lpid);
           }else{
               if( searchData.lproduct_ids.includes(lpid) ) return;
               searchData.lproduct_ids.push(lpid);
           }
           item = createSelectedProdElm(prodName, lpid, TYPE_LPRODUCT, !!isAllVersion);
       }else if( lvid ){
           if( searchData.lversion_ids.includes(lvid) ) return;
           searchData.lversion_ids.push(lvid);
           item = createSelectedProdElm(prodName, lvid, TYPE_LVERSION);
       }else{//通常の操作ではここには入らない
           return false;
       }

       $('#filter-products-selected-list').append(item);
       $('#filter-products-selected-data').val(JSON.stringify(searchData));
   });

   //検索
   $('#exec-filter-products').on('click', function(){
       const searchData = JSON.parse($('#filter-products-selected-data').val());
       var filters = JSON.parse($('#pages_filters').val());
       filters.products = searchData;
       execute_filter(filters);
   });

   //検索リセット
   $('#reset-filters-product').on('click', function(){
       resetFilterProducts();
   });
}
