/* coding: utf-8 */
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){
    enable_dropdown_balloon();
    $('.cancel-import').on('click', function(){
        $('#form-to-index-page').submit();
    });

    function import_apply_with_progress_bar(){
        var import_apply_path = $('#sidfm_local_vuls_import_apply_path').val();
        var actions = JSON.parse($('#actions').val());
        var progress_window = get_progress_bar();
        $('body').append(progress_window);
        var executed_actions = 0;
        var total_actions = actions.length;
        var err_messages = [];
        var err_cnt = 0;
        var cnt = 0;
 
        var send_data_of_import = function(){
            action = actions[cnt];
            action_data = {'action_data': JSON.stringify(action)};
            $.ajax({
                type: 'POST',
                url: import_apply_path,
                data: action_data,
            }).done(function(result){
                err_message = result['err_message'];
                if( err_message.length > 0 ){
                    err_messages.push(err_message);
                    err_cnt += 1;
                }
                executed_actions += 1;
                var percentage = (executed_actions / total_actions) * 100;
                if( percentage >= 99 && percentage < 100 ){
                    percentage = 99;
                }else{
                    percentage = Math.round(percentage);
                }
                $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                if( percentage == 100 ){
                    setTimeout(function(){//progress barのbarが満たされるまで待つ
                        if(err_messages.length > 0){
                            //err_messages = Array.from(err_messages);
                            alert(err_messages.join('\n') + (err_cnt == total_actions ? '' : '\n※他のデータの登録は完了しています。') + '\nローカルプロダクト設定画面に移動します。');
                            $('#form-to-index-page').submit();
                        }else{
                            $('#form-to-index-page').submit();
                        }
                    },800);
                }else{
                    cnt += 1;
                    send_data_of_import();
                }
            });
        };

        send_data_of_import();
    }

    $('.execute-import-apply').on('click', function(){
        var get_issue_related_vul_ids_path = $('#get_issue_related_vul_ids_path').val();
        var actions = JSON.parse($('#actions').val());
        var vul_ids = [];
        var delete_vul_ids = [];
        var vul_names = {};
        actions.forEach(function(action){
            if(action['action'] == 'delete'){
                var vul_id = parseInt(action['vul_id']);
                vul_ids.push(vul_id);
                delete_vul_ids.push(vul_id);
                vul_names[vul_id] = action['vul_title'];
            }else if(action['action'] == 'modify'){
                var vul_id = parseInt(action['vul_id']);
                vul_ids.push(vul_id); 
                vul_names[vul_id] = action['vul_title'];
            }
        });
        $.ajax({
            type: 'POST',
            url: get_issue_related_vul_ids_path,
            data: { 'vul_ids': JSON.stringify(vul_ids) }
        }).done(function(vul_ids){
            if( vul_ids.length > 0 ){
                var issue_related_vul_names = [];
                var is_delete_vul = false;
                vul_ids.forEach(function(vul_id){ 
                    if( delete_vul_ids.includes(vul_id) ){
                        is_delete_vul = true;
                    }
                    issue_related_vul_names.push(vul_names[vul_id]);
                });
                issue_related_vul_names.sort();
                $('#VulNameArea > *').remove();
                $('#modalIssueRelatedVuls-caution').html(
                    '以下のローカル脆弱性は脆弱性チケットに関連しているため、実行すると' +
                    '<span class="text-danger">関連する脆弱性チケットの変更に関する項目と、対応状況(ステータス)が、' + 
                    '次のホストの脆弱性同期時に変更される可能性があります。</span><br>' +
                    (is_delete_vul ? '<span class="text-danger">また、削除するローカル脆弱性に関連する脆弱性チケットは、実行直後に削除されます。</span><br>' : '') + 
                    '脆弱性チケットの変更に関して問題が無い場合、OKボタンをクリックして下さい。'
                );
                issue_related_vul_names.forEach(function(vul_name){
                    var tr = $('<tr>');
                    var td = $('<td>').text(vul_name);
                    tr.append(td);
                    $('#VulNameArea').append(tr);
                    $('#modalIssueRelatedVuls').modal('show');
                }); 
            }else{
                import_apply_with_progress_bar();
            }
        });
    });

    $('#exec-import-apply-after-conf').on('click', function(){
        import_apply_with_progress_bar();
    });
});
